unit u_DXE2SourceGuard;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, BugShooter;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button3: TButton;
    Button5: TButton;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Button4: TButton;
    Button6: TButton;
    SGBugShooter1: TSGBugShooter;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
{This example is to show memory Leak..!!}


ShowMessage('This will leak memory');
TButton.Create(nil);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  {This example is to show exception..!!}
  Raise Exception.CreateFmt('Invalid name : ''%s''', [name]);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
str,temsTlist : TStringList;
i,j : integer;
begin
  {This example is to show NO memory Leak..!!}
  ShowMessage('This will NOT leak memory');
   str        :=TStringList.Create;
   temsTlist  :=TStringList.Create;
  try
  finally
    str.Add('Helloo');
    temsTlist.add('Add another');
  begin
    str.Free;
    temsTlist.Free;
  end;
   end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
strlist : TStringList;
strValue : string;
begin
 {This example is to show exception..!!}
 try
 strlist  :=TStringList.Create;
 strValue :=strlist[3];       {List out of bounds error}
 finally
 strlist.Free;
 end;
end;
procedure TForm1.Button5Click(Sender: TObject);
var
str : TStringList;
begin
    {This example is to show memory Leak..!!}
    ShowMessage('This will leak memory');
    str:=TStringList.Create;
    str.add('MemChk');
end;

procedure TForm1.Button6Click(Sender: TObject);
 var
  myButtonForAccessViolation : TButton;
begin
{This example is to show exception..!!}
 try
    myButtonForAccessViolation :=TButton.Create(nil);
    myButtonForAccessViolation.OnClick(Sender);
 finally
     myButtonForAccessViolation.Free;
 end;
end;

end.
